﻿Type=Service
Version=6.31
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
   Private gps As GPS
   Private timer1 As Timer
   Dim NewTime As String
   Dim lNewTime As Long
   Dim lNewTime2 As Long
   Dim setEnable As Boolean = True
   Dim setNow As Boolean = False

End Sub

Sub Service_Create

   timer1.Initialize("timer1", 30000)
   timer1.Enabled = True
   
   gps.Initialize("gps")
   gps.Start(0, 0)
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Sub Service_Destroy

End Sub

Sub GPSenable(enableValue As Boolean)
	If enableValue Then
		gps.Start(0, 0)
	Else
		gps.Stop
	End If
End Sub

Sub gps_NMEA (TimeStamp As Long, Sentence As String)
   'Log($"$DateTime{TimeStamp}"$)
   'Log(Sentence)
End Sub

Sub GPS_LocationChanged (Location1 As Location)

    lNewTime = Location1.Time
	
	'Log("Location Time: " & lNewTime)
	NewTime = lNewTime
    NewTime = (NewTime.substring2(0,10))

	If setNow And setEnable Then
	'If ((setNow = True) And (setEnable = True)) Then
		shellCmd("date " & NewTime)
		'Log("Set date: " & lNewTime)
		lNewTime2 = lNewTime
		setNow = False
		'ToastMessageShow("Set Date & Time", False)
	End If
	
End Sub

Sub timer1_tick()
	setNow = True
End Sub

Sub updateTextMain()
	CallSubDelayed3(Main, "updateText", lNewTime, lNewTime2)
End Sub

Sub enableAutoSet(setEnable1 As Boolean)
	setEnable = setEnable1
End Sub

Sub shellCmd(Command_in As String) As String
	'Dim Result As Int
	Dim Command, Runner As String
	Dim StdOut, StdErr As StringBuilder
	Dim Ph As Phone
		
	Runner = File.Combine(File.DirInternalCache, "runner")
	Command = File.Combine(File.DirInternalCache, "command")

	File.WriteString(File.DirInternalCache, "runner", "su < " & Command)
	File.WriteString(File.DirInternalCache, "command", Command_in & CRLF & "exit") 'Any commands via crlf, and exit at end 
	StdOut.Initialize
	StdErr.Initialize

	'Result = Ph.Shell("sh", Array As String(Runner), StdOut, StdErr)
	Ph.Shell("sh", Array As String(Runner), StdOut, StdErr)

	Return StdOut.tostring
End Sub